<?php
// usage: initweb.php?passwd=pass

$rootdir = realpath(dirname(__FILE__));
if (!file_exists("./src/settings.php"))
	die("Cannot find settings.php file");
require_once("./src/settings.php");
$dirs = array($pagedir, $uplddir, $imgsdir, $sndsdir, $datadir, $styldir, "$rootdir/sessions");
$showmsg = "root=$rootdir<br/>pages=$pagedir<br/>datadir=$datadir<br/>srcdir=$srcdir<br/><br/>Actions taken:<br/>";

if (!function_exists('file_put_contents'))
{
	function file_put_contents($file, $text)
	{
		$ret = false;
		$fh = fopen($file, "w");
		if ($fh)
		{
			$ret = fwrite($fh, $text);
			fclose($fh);
		}
		return $ret;
	}
}

foreach ($dirs as $dir)
{
	if (!is_dir($dir))
	{
		if (mkdir($dir))
		{
			$showmsg .= "Created $dir <br/>\n";
			// This next line is needed on hosted websites where the
			// server runs as a different account (i.e. HTTPD)
			// irritating.. but necessary so that uploads and
			// page creation will work.
			chmod($dir, 0777);
		}
		else
			$showmsg .= "*** Cannot create $dir<br/>\n";
	}
	else
		$showmsg .= "Directory $dir already exists<br/>\n";
	// creating a dummy index.php inhibits directory indexing from the server.
	if (!file_exists("$dir/index.php"))
		file_put_contents("$dir/index.php", "<?php ?>");
}

if (isset($_GET['passwd']))
{
	$passwd = md5($_GET['passwd']);

	if ($userXML)
	{
		$usrfile = "$datadir/users.xml";
		if (!file_exists($usrfile))
		{
			file_put_contents($usrfile, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><users><user id=\"admin\" pass=\"$passwd\" priv=\"aeu\" /></users>");
			$showmsg .= "Created $usrfile.<br/>";
		}
		else
			$showmsg .= "$usrfile exists.<br/>";
	}
	else
	{
		$usrfile = "$datadir/users.txt";
		if (!file_exists($usrfile))
		{
			if ($userTXT)
				file_put_contents($usrfile, "<?xml version=\"1.0\"?><users><user id=\"admin\" pass=\"$passwd\" priv=\"aeu\" /></users>");
			else
				file_put_contents($usrfile, $passwd);
			$showmsg .= "Created $usrfile.<br/>";
		}
		else
			$showmsg .= "$usrfile exists.<br/>";
	}
}
else
	$showmsg .= "No password indicated, skipping user file initialization...<br/>";

$showmsg .= "<br/>\n";

if ($tocXML)
{
	$tocfile = "$pagedir/toc.xml";
	if (!file_exists($tocfile))
	{
		file_put_contents($tocfile, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><toc><item id=\"default\" title=\"Home\" /></toc>");
		$showmsg .= "Created $tocfile<br/>";
	}
	else
		$showmsg .= "$tocfile exists.<br/>";
}
else if ($tocTxt)
{
	$tocfile = "$pagedir/toc.txt";
	if (!file_exists($tocfile))
	{
		file_put_contents($tocfile, "default=Home");
		$showmsg .= "Created $tocfile<br/>";
	}
	else
		$showmsg .= "$tocfile exists.<br/>";
}

echo '<html><head><title>WEB Initialization</title></head><body>';
echo $showmsg;
echo 'You should delete this file (initweb.php) to be safe.<p><a href="index.php">Enter web site.</a></p></body></html>';
