<?php
if (!isset($rootdir))
	die("");

if (!function_exists('file_put_contents'))
{
	function file_put_contents($file, $text)
	{
		$fh = fopen($file, "w");
		if ($fh)
		{
			fwrite($fh, $text);
			fclose($fh);
		}
	}
}

class userSingle
{
	var $loginid;
	var $priv;
	var $uname;
	var $email;

	function userSingle()
	{
		$this->ClearPriv();
	}

	function Load()
	{
	}

	function InitUser($usrid)
	{
		global $datadir;

		$this->loginid = $usrid;
		$this->SetPriv("aeu");
		if (file_exists("$datadir/name.txt"))
			$this->uname = preg_replace("/[\r\n]/", "", file_get_contents("$datadir/name.txt"));
		else
			$this->uname = '';
		if (file_exists("$datadir/email.txt"))
			$this->email = preg_replace("/[\r\n]/", "", file_get_contents("$datadir/email.txt"));
		else
			$this->email = '';
	}

	function ClearPriv()
	{
		$this->priv = array('admin' => false, 'edit' => false, 'upld' => false);
	}

	function SetPriv($upriv)
	{
		$this->priv['admin'] = strpos($upriv, "a") !== false;
		$this->priv['edit']  = strpos($upriv, "e") !== false;
		$this->priv['upld']  = strpos($upriv, "u") !== false;
	}

	function IsAdmin()
	{
		return $this->priv['admin'];
	}

	function CanEdit()
	{
		return $this->priv['edit'];
	}

	function CanUpload()
	{
		return $this->priv['upld'];
	}

	function LoginUser($usrid, $upass)
	{
		global $datadir;
		$thepass = file_get_contents("$datadir/users.txt");
		if ($thepass == $upass)
		{
			$this->InitUser($usrid);
			return true;
		}
		return false;
	}

	function LogoutUser()
	{
		unset($this->loginid);
		$this->ClearPriv();
		$this->uname = "";
		$this->email = "";
	}

	function UpdateUser($usrid, $upass, $upriv, $uname, $email)
	{
		global $datadir;

		$this->SetPriv($upriv);
		$this->uname = $uname;
		$this->email = $email;
		if ($upass)
			file_put_contents("$datadir/users.txt", md5($upass));
		file_put_contents("$datadir/name.txt", $uname);
		file_put_contents("$datadir/email.txt", $email);
		return true;
	}

	function DeleteUser($usrid)
	{
		return true;
	}

	function GetUsersList()
	{
		$userslist = array($this->loginid);
		return $userslist;
	}

	function GetUser($usrid)
	{
		return $this;
		/*$usr = new userSingle;
		$usr->InitUser($usrid);
		return $usr;*/
	}
}

class userXML extends userSingle
{
	var $doc;
	var $root;
	var $err;

	function userXML()
	{
		userSingle::userSingle();
		$this->doc = NULL;
		$this->root = NULL;
		$this->err = "";
	}

	function Load()
	{
		global $datadir;

		$usrxml = "$datadir/users.xml";
		if (file_exists($usrxml))
		{
			$this->doc = domxml_open_file($usrxml);
			if ($this->doc)
				$this->root = $this->doc->document_element();
		}
	}

	function GetError()
	{
		return $this->err;
	}

	// This is called internally to init a user object for editing, not login
	function InitUser($usrid)
	{
		$this->loginid = $usrid;
		$usernode = $this->FindUser($usrid);
		if ($usernode !== false)
		{
			$this->SetPriv($usernode->get_attribute("priv"));
			$this->uname = $usernode->get_attribute("name");
			$this->email = $usernode->get_attribute("email");
		}
		else
		{
			$this->ClearPriv();
			$this->uname = '';
			$this->email = '';
		}
	}

	function LoginUser($usrid, $upass)
	{
		if (!($doc = $this->doc) || !($root = $this->root))
			return false;
		$usernode = $this->FindUser($usrid);
		if ($usernode !== false)
		{
			if ($upass == $usernode->get_attribute("pass"))
			{
				$this->loginid = $usrid;
				$this->SetPriv($usernode->get_attribute("priv"));
				$this->uname = $usernode->get_attribute("name");
				$this->email = $usernode->get_attribute("email");
				$this->err = "Logged in OK.";
				return true;
			}
		}
		$this->err = "Invalid usrid or password.";

		return false;
	}

	function UpdateUser($usrid, $upass, $upriv, $uname, $email)
	{
		global $datadir;

		$isadmin = $this->priv['admin'];
		if ($usrid != $this->loginid && !$isadmin)
		{
			$this->err = "This function requires admin privilege.";
			return false;
		}

		if (!($doc = $this->doc) || !($root = $this->root))
		{
			$this->err = "No users file.";
			return false;
		}

		$usernode = $this->FindUser($usrid);
		if ($usernode !== false)
		{
			if ($upass)
				$usernode->set_attribute("pass", md5($upass));
			if ($isadmin && $upriv)
				$usernode->set_attribute("priv", $upriv);
			$usernode->set_attribute("name", $uname);
			$usernode->set_attribute("email", $email);
		}
		else if ($isadmin)
		{
			$usernode = $doc->create_element("user");
			$usernode = $root->append_child($usernode);
			$usernode->set_attribute("id", $usrid);
			$usernode->set_attribute("pass", md5($upass));
			$usernode->set_attribute("priv", $upriv);
			$usernode->set_attribute("name", $uname);
			$usernode->set_attribute("email", $email);
		}
		else
		{
			$this->err = "User $usrid not found and not admin.";
			return false;
		}

		if ($usrid == $this->loginid)
		{
			$this->uname = $uname;
			$this->email = $email;
		}

		return $doc->dump_file("$datadir/users.xml", false, true);
	}

	function DeleteUser($usrid)
	{
		global $datadir;

		if (!($doc = $this->doc) || !($root = $this->root))
		{
			$this->err = "Users file is not loaded.";
			return false;
		}
		$isadmin = $this->priv['admin'];
		if (!$isadmin)
		{
			$this->err = "This function requires admin privilege.";
			return false;
		}
		if ($usrid == $this->loginid)
		{
			$this->err = "Cannot delete the logged-in account.";
			return false;
		}
		$usernode = $this->FindUser($usrid);
		if ($usernode !== false)
		{
			$root->remove_child($usernode);
			unset($usernode);
			return $doc->dump_file("$datadir/users.xml", false, true);
		}
		$this->err = "User $usrid not found.";
		return false;
	}

	function FindUser($id)
	{
		if ($this->doc && $this->root)
		{
			$userlist = $this->root->get_elements_by_tagname("user");
			foreach ($userlist as $usernode)
			{
				if ($usernode->get_attribute("id") == $id)
					return $usernode;
			}
		}
		
		return false;
	}

	function GetUsersList()
	{
		$userslist = array();
		if ($this->doc && $this->root)
		{
			$userlist = $this->root->get_elements_by_tagname("user");
			foreach ($userlist as $usernode)
				$userslist[] = $usernode->get_attribute("id");
		}
		return $userslist;
	}

	function GetUser($usrid)
	{
		if ($usrid == $this->loginid)
			return $this;

		$usr = new userXML;
		$usr->loginid = $usrid;
		$usernode = $this->FindUser($usrid);
		if ($usernode !== false)
		{
			$usr->SetPriv($usernode->get_attribute("priv"));
			$usr->uname = $usernode->get_attribute("name");
			$usr->email = $usernode->get_attribute("email");
		}
		else
		{
			$usr->ClearPriv();
			$usr->uname = '';
			$usr->email = '';
		}

		return $usr;
	}
}

// txt file in the form 
//	usrid,pass,priv,name,email:usrid,pass,priv,name,email...
class userTXT extends userSingle
{
	var $users;
	var $err;

	function userTXT()
	{
		userSingle::userSingle();
	}

	function Load()
	{
		global $datadir;

		$this->err = "";
		$usrfile = "$datadir/users.txt";
		if (file_exists($usrfile))
		{
			$usrtxt = file_get_contents($usrfile);
			$this->users = explode(":", $usrtxt);
		}
		else
			$this->users = array();
	}

	function GetError()
	{
		return $this->err;
	}

	function InitUser($id)
	{
		$this->loginid = $id;
		if (($ndx = $this->FindUser($usrid)) !== false)
		{
			list($id,$pwd,$pri,$name,$email) = explode(",", $this->users[$ndx]);
			$this->SetPriv($pri);
			$this->uname = $name;
			$this->email = $email;
		}
		else
		{
			$this->ClearPriv();
			$this->uname = '';
			$this->email = '';
		}
	}

	function LoginUser($usrid, $upass)
	{
		if (($ndx = $this->FindUser($usrid)) !== false)
		{
			list($id,$pwd,$pri,$name,$email) = explode(",", $this->users[$ndx]);
			if ($upass == $pwd)
			{
				$this->loginid = $usrid;
				$this->SetPriv($pri);
				$this->uname = $name;
				$this->email = $email;
				return true;
			}
		}

		return false;
	}

	function UpdateUser($usrid, $upass, $upriv, $uname, $email)
	{
		global $datadir;

		$isadmin = $this->priv['admin'];
		if (($ndx = $this->FindUser($usrid)) !== false)
		{
			list($oldid,$oldpass,$oldpriv,$oldname,$oldemail) = explode(",", $this->users[$ndx]);
			if (!$isadmin)
				$upriv = $oldpriv;
			if (!$upass)
				$upass = $oldpass;
			else
				$upass = md5($upass);
			$this->users[$ndx] = "$usrid,$upass,$upriv,$uname,$email";
			$this->uname = $uname;
			$this->email = $email;
		}
		else if ($isadmin)
		{
			$upass = md5($upass);
			$this->users[] = "$usrid,$upass,$upriv,$uname,$email";
		}
		file_put_contents("$datadir/users.txt", implode(":", $this->users));
	}


	function DeleteUser($usrid)
	{
		global $datadir;

		if (($ndx = $this->FindUser($usrid)) !== false)
		{
			unset($this->users[$ndx]);
			file_put_contents("$datadir/users.txt", implode(":", $this->users));
		}
	}

	function FindUser($id)
	{
		$count = count($this->users);
		for ($ndx = 0; $ndx < $count; $ndx++)
		{
			$usr = explode(",", $this->users[$ndx]);
			if ($usr[0] == $id)
				return $ndx;
		}
		return false;
	}

	function GetUsersList()
	{
		$userslist = array();
		for ($ndx = 0; $ndx < $count; $ndx++)
		{
			$usr = explode(",", $this->users[$ndx]);
			$userslist = $usr[0];
		}
		return $userslist;
	}

	function GetUser($usrid)
	{
		if ($usr == $this->loginid)
			return $this;

		$usr = new userTXT;
		$usr->loginid = $usrid;
		$usr->pass = '';
		if (($ndx = $this->FindUser($usrid)) !== false)
		{
			list($id,$pwd,$pri,$name,$email) = explode(",", $this->users[$ndx]);
			$usr->SetPriv($pri);
			$usr->uname = $name;
			$usr->email = $email;
		}
		else
		{
			$usr->ClearPriv();
			$usr->uname = '';
			$usr->email = '';
		}
		return $usr;
	}
}

?>
