<?php
if (!isset($rootdir))
	die("");

//////////////////////////////////////////////////////////////////////////////////
// ProcessRequest handles URL option interpretation. Add new functionality here.
//////////////////////////////////////////////////////////////////////////////////
function ProcessRequest()
{
	global $stuff, $edit, $editdata, $edituser, $showmsg;

	$stuff = "default";
	$edit = false;
	$editdata = false;
	$edituser = false;
	$showmsg = "";

	if (isset($_GET['page']))
		DoPage();
	else if (isset($_GET['edit']))
		DoEdit();
	else if (isset($_GET['update']))
		DoUpdate();
	else if (isset($_GET['upload']))
		DoUpload();
	else if (isset($_GET['stylesheet']))
		DoStylesheet();
	else if (isset($_GET['edittoc']))
		DoEditTOC();
	else if (isset($_GET['rss']))
		DoRSS();
	else if (isset($_GET['download']))
		DoDownload();
	else if (isset($_GET['admin']))
		DoAdmin();
	else if (isset($_GET['print']))
		DoPrint();
	else if (isset($_GET['n'])) // hack for backward compatibility with PMWiki
	{
		$_GET['page'] = $_GET['n'];
		DoPage();
	}
	// else - load the default page.
}

//////////////////////////////////////////////////////////////////////////////////
// GetCurrentPage retrieves a page and emits it to the output stream.
//////////////////////////////////////////////////////////////////////////////////
function GetCurrentPage($file, $isedit)
{
	// all globals have to be here so that they can be referenced inside pages
	global $pagedir, $srcdir, $datadir, $imgsdir, $sndsdir, $uplddir, $rootdir, $styldir;
	global $baseweb, $rooturl, $mceurl;
	global $stuff, $edit, $editdata, $edituser, $showmsg, $theUser, $theTOC, $pagepath;

	$found = true;
	if (!$file)
		$file = "default";
	$pagename = "$pagedir/$file.html";
	if (!file_exists($pagename) && !$isedit)
	{
		$found = false;
		if (isset($pagepath))
		{
			foreach ($pagepath as $dir)
			{
				$pagename = "$dir/$file.html";
				if (file_exists($pagename))
				{
					$found = true;
					break;
				}
			}
		}
	}
	if ($found)
	{
		if ($isedit)
			@readfile($pagename);
		else
			@include($pagename);
	}
	else if ($isedit)
		echo "<h2>Title</h1><p>Content</p>";
	else
		echo "Cannot locate page $file.";
}

//////////////////////////////////////////////////////////////////////////////////
// GetContentList retrieves a list of available pages.
//////////////////////////////////////////////////////////////////////////////////
function GetContentList()
{
	global $theTOC;
	return $theTOC->GetTOC();
}


//////////////////////////////////////////////////////////////////////////////////
// User administration
//////////////////////////////////////////////////////////////////////////////////
function DoAdmin()
{
	$act = $_GET['admin'];
	if ($act == 'upduser')
		UpdateUser();
	else if ($act == 'edtuser')
		EditUser();
	else if ($act == 'deluser')
		DeleteUser();
}

function DoLogin()
{
	global $theUser, $showmsg, $theUser;

	if (isset($_GET['login']))
	{
		$chkid = $_GET['login'];
		$passwd = $_GET['pass'];
	}
	else
	{
		$chkid = $_POST['id'];
		$passwd = $_POST['pass'];
	}

	if ($theUser->LoginUser($chkid, md5($passwd)))
	{
		$_SESSION['login'] = $chkid;
		$showmsg = "Login as $chkid, $theUser->uname, $theUser->email";
	}
	else
		$showmsg = "Login failed.";
}

function DoLogout()
{
	global $theUser, $showmsg;
	
	$theUser->LogoutUser();
	unset($_SESSION['login']);
	if (isset($_COOKIE[session_name()]))
		setcookie(session_name(), '', 1, '/');

	session_destroy();
	$showmsg = "Logged out.";
}

function UpdateUser()
{
	global $showmsg, $theUser;

	$usrid = "";
	if (isset($_POST['uid']))
		$usrid = $_POST['uid'];
	if (!$usrid)
	{
		$showmsg = "User ID cannot be blank.";
		return;
	}

	$upass = "";
	if (isset($_POST['upass']))
		$upass = $_POST['upass'];
	$uname = "";
	if (isset($_POST['uname']))
		$uname = $_POST['uname'];
	$email = "";
	if (isset($_POST['email']))
		$email = $_POST['email'];

	$upriv = "";
	if (isset($_POST['padmin']) && $_POST['padmin'] == "on")
		$upriv .= "a";
	if (isset($_POST['pedit']) && $_POST['pedit'] == "on")
		$upriv .= "e";
	if (isset($_POST['pupld']) && $_POST['pupld'] == "on")
		$upriv .= "u";

	$showmsg = "Update $usrid, $upass, $upriv, $uname, $email";
	if ($theUser->UpdateUser($usrid, $upass, $upriv, $uname, $email))
		$showmsg .= "Updated $usrid";
	else
		$shomsg .= "<br/>Cannot update $usrid.".$theuser->err;
}

function EditUser()
{
	global $stuff, $theUser, $edituser;
	if ($theUser->IsAdmin())
		$edituser = $_GET['usrid'];
	else
		$edituser = $theUser->loginid;
	$stuff = "_admin";
}

function DeleteUser()
{
	global $theUser, $showmsg;

	if ($theUser->IsAdmin())
	{
		$usrid = "";
		if (isset($_GET['usrid']))
			$usrid = $_GET['usrid'];
		if (!$usrid)
		{
			$showmsg = "User ID cannot be blank.";
			return;
		}
		if ($usrid == 'admin')
		{
			$showmsg = "Cannot delete admin user.";
			return;
		}

		if ($theUser->DeleteUser($usrid))
			$showmsg = "Deleted $usrid";
		else
			$showmsg = "$usrid Not deleted.";
	}
	else
		$showmsg = "Cannot delete users.";
}

//////////////////////////////////////////////////////////////////////////
// File management
//////////////////////////////////////////////////////////////////////////
$uplderr = array(
       0=>"There is no error, the file uploaded with success", 
       1=>"The uploaded file exceeds the upload_max_filesize directive in php.ini", 
       2=>"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
       3=>"The uploaded file was only partially uploaded",
       4=>"No file was uploaded",
       6=>"Missing a temporary folder" ,
	   7=>"Failed to write file to disk."
);

function CleanPath($path)
{
	$path = preg_replace("/[ \\t<>]+/", "_", $path);
	$path = preg_replace("/['&*%?+;:|,#@()]/", "", $path);
	return $path;
}

//////////////////////////////////////////////////////////////////////////////////
// Page and data file functions
//////////////////////////////////////////////////////////////////////////////////
function DoPage()
{
	global $stuff;

	$stuff = $_GET['page'];
	if (isset($_POST['dosave']))
		DoSave();
	else if (isset($_POST['login']) || isset($_GET['login']))
		DoLogin();
	else if (isset($_GET['logout']))
		DoLogout();
	// else default is to display page as content...
}

function DoUpload()
{
	global $stuff, $uplddir, $pagedir, $uplderr, $showmsg, $theUser;

	if (!$theUser->CanUpload())
	{
		$showmsg = "You must have upload priveleges to upload files.";
		return;
	}

	$stuff = "_upload";

	$upldfile = "";
	if (isset($_POST['targdir']))
		$targdir = $_POST['targdir'];
	else
		$targdir = $uplddir;
	if (isset($_FILES['upldfile']['name']))
		$upldfile = $_FILES['upldfile']['name'];
	if ($upldfile != "")
	{
		if (isset($_FILES['upldfile']['error']))
		{
			$e = $_FILES['upldfile']['error']; 
			if ($e != 0 && $e != 4)
				$showmsg = "There was a problem uploading the file: ".$uplderr[$e];
		}
		$upldfile = CleanPath(basename($upldfile));
		$tmpfile = $_FILES['upldfile']['tmp_name'];
		$path = "$targdir/$upldfile";
		if (!move_uploaded_file($tmpfile, $path))
			$showmsg = "Cannot save upload file $path";
		else
		{
			// this next line is needed when the webserver runs under a different account
			// if we don't chomd() we can't delete the file from cpanel or ftp
			chmod($path, 0666);
			$showmsg = "Upload complete: $path";
		}
	}
	else
		$showmsg = "No file specified for upload";
}

function DoEdit()
{
	global $stuff, $edit, $editfancy, $showmsg, $theUser;

	if ($theUser->CanEdit())
	{
		$edit = $_GET['edit'];
		if (isset($_GET['fancy']))
		{
			if ($_GET['fancy'] == "yes")
				$editfancy = true;
			else
				$editfancy = false;
		}
		// else use default setting from settings.php
	}
	else
	{
		$stuff = $_GET['edit'];
		$showmsg = "You must be logged in to edit this page";
	}
}

function DoSave()
{
	global $stuff, $pagedir, $showmsg, $theTOC, $theUser;

	$stuff = $_GET['page'];
	if ($theUser->CanEdit())
	{
		$pagname = "$pagedir/$stuff.html";
		if (file_put_contents($pagname, $_POST['content']) !== false)
		{
			$showmsg = "$stuff was updated successfully.";
			if (isset($_POST['index']))
			{
				if ($_POST['index'] == "on")
					$theTOC->UpdateTOC($stuff, $_POST['title']);
				else
					$theTOC->RemoveTOC($stuff);
			}
			header("Location: index.php?page=$stuff");
			exit(0);
		}
		else
			$showmsg = "ERROR: could not write to $pagname";
	}
	else
		$showmsg = "You must be logged in to save this page";
}

function DoUpdate()
{
	global $showmsg, $theTOC, $theUser;

	if (isset($_POST['dosave']))
	{
		if (file_put_contents($_POST['update'], $_POST['content']) !== false)
			$showmsg = $_POST['update']." updated.";
		else
			$showmsg = "ERROR: File update failed.";
	}
	else if (isset($_POST['docancel']))
	{
		$showmsg = "Canceled. File was not written.";
		$stuff = "default";
	}
}


function DoEditTOC()
{
	global $stuff, $showmsg, $theTOC, $editfancy, $tocXML, $tocTXT, $theUser;

	if (!$theUser->CanEdit())
	{
		$showmsg = "You must be logged in to edit this page";
		return;
	}
	$cmd = $_GET['edittoc'];
	if ($cmd == "update")
	{
		if (isset($_POST['dosave']))
		{
			$ok = $theTOC->SetTOC($_POST['content']);
			if ($ok !== false)
				$showmsg = "TOC updated.";
			else
				$showmsg = "ERROR: TOC update failed with $ok.";
			//$showmsg .= "Content: ".htmlspecialchars($_POST['content'])." (end)";
		}
		else if (isset($_POST['docancel']))
			$showmsg = "Canceled.";
	}
	else if ($cmd == "edit")
	{
		if ($tocXML || $tocTXT)
		{
			$stuff = "_edittoc";
			$editfancy = false;
		}
		else
			$showmsg = "Cannot edit TOC using directory listing. (maybe later...)";
	}
	else
		$showmsg = "EditTOC: invalid command: $cmd";
}

function DoStylesheet()
{
	global $stuff, $styldir, $rootdir, $editfancy, $showmsg;

	$stuff = "default";
	$cmd = $_GET['stylesheet'];
	if ($cmd == "edit")
	{
		// stylesheets require a special edit form that is
		// loaded from the _style.html page
		$stuff = "_style";
		$editfancy = false;
	}
	else if ($cmd == "post")
	{
		if (isset($_POST['dosave']))
		{
			if (isset($_POST['saveas']))
				$style = $_POST['saveas'];
			if ($style != "")
				$file = "$styldir/$style";
			else
				$file = "$rootdir/style.css";
			file_put_contents($file, $_POST['content']);
			$showmsg = "Style sheet $file updated.";
		}
		else
			$showmsg = "canceled.";
	}
	else if ($cmd == "change")
	{
		if (isset($_POST['style']))
		{
			// copy $styldir/$_POST['style'] to $rootdir/style.css
			$style = $_POST['style'];
			file_put_contents("$rootdir/style.css", file_get_contents("$styldir/$style"));
			$showmsg = "Changed style to $styldir/$style.";
		}
		else
			$showmsg = "No style set.";
	}
	else
		$showmsg = "You forgot the command on stylesheet.";
}

function DoRSS()
{
	global $showmsg, $theTOC, $baseurl, $siteTitle, $siteDesc, $rooturl, $theUser;

	$count = $_GET['rss'];
	if ($count == 'all')
		$count = 1000;
	$items = $theTOC->GetRSS();

	header("Content-Type: text/xml; charset=UTF-8");

	echo '<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0">
<channel>
	<title>', $siteTitle, '</title>
	<link>', $rooturl, '</link>
	<description>', $siteDesc, '</description>
	<pubDate>', gmdate('r'), '</pubDate>
	<language>en</language>
';
	$ndx = 0;
	foreach ($items as $item)
	{
		// $item is an array(pgid, title, date, content)
		echo "<item><title>$item[1]</title>\n";
		echo "<link>{$rooturl}index.php?page=$item[0]</link>\n";
		echo "<pubDate>$item[2]</pubDate>\n";
		echo "<guid isPermaLink=\"true\">{$rooturl}index.php?page=$item[0]</guid>\n";
		if ($item[4])
		{
			$auser = $theUser->GetUser($item[4]);
			echo "<author>$auser->email ($auser->uname)</author>\n";
		}
		echo '<description><![CDATA[', $item[3], ']]></description></item>';
		$ndx++;
		if ($ndx >= $count)
			break;
	}
	echo '
	</channel>
</rss>';

	// We don't return to Main, since we have already sent the stuff..
	exit(0);
}

function DoDownload()
{
	global $uplddir, $showmsg;

	$file = $_GET['download'];
	$path = "$uplddir/$file";
	if (file_exists($path))
	{
		$len = @filesize($path); 
		//$content = @file_get_contents($path);

		@ob_end_clean(); 
		@ini_set('zlib.output_compression', 'Off'); 
		header('Pragma: public'); 
		header('Last-Modified: '.gmdate('D, d M Y H:i:s') . ' GMT'); 
		header('Cache-Control: no-store, no-cache, must-revalidate'); // HTTP/1.1 
		header('Cache-Control: pre-check=0, post-check=0, max-age=0'); // HTTP/1.1 
		header('Content-Transfer-Encoding: none'); 
		header('Content-Type: application/octetstream; name="' . $file . '"'); //This should work for IE & Opera 
		header('Content-Type: application/octet-stream; name="' . $file . '"'); //This should work for the rest 
		header('Content-Disposition: inline; filename="' . $file . '"'); 
		header("Content-length: $len"); 

		//echo $content; 
		@readfile($path);
		exit(0); 
	}

	$showmsg = "Cannot open $path.";
}

function DoPrint()
{
	global $stuff, $srcdir, $rootdir, $styldir, $theTOC;
	$stuff = $_GET['print'];
	@include("$srcdir/print.php");
	exit(0);
}

if (!function_exists('file_put_contents'))
{
	function file_put_contents($file, $text)
	{
		$ok = false;
		$fh = fopen($file, "w");
		if ($fh)
		{
			$ok = fwrite($fh, $text);
			fclose($fh);
		}
		return $ok;
	}
}


?>
